GUI (Grafiksel Kullanıcı Arayüzü)
Panic & Recover
Panic ve Recover, Golang’de hata ayıklama için kullanılan anahtar kelimelerdir. Size bunu daha iyi ve akılda kalıcı anlatmak için teorik anlatım yerine uygulamalı öğretim yapmak istiyorum. Böylece daha akılda kalıcı olur. Aşağıda panic durumu oluşturan bir örnek göreceğiz:
1
package main
2
func main() {
3
sayilar := make([]int, 5)
4
sayilar[6] = 10
5
}
Copied!
Yukarıda make fonksiyonu ile sayilar adında uzunluğu 5 birimden oluşan bir int dizi oluşturduk. Bu bildiğimiz sayısal 5 tane değişken tutan bir dizi aslında. Ama altında sayilar dizisinin 6. indeksine 10 değerini atamak istedik. Fakat sayilar dizesinin 6. indeksi mantıken bulunmamakta. Bu haldeyken programımız panic hatası verecektir ve çıktımız aşağıdaki gibi olacaktır.
panic: runtime error: index out of range goroutine 1 [running]: main.main() /home/ksc10/Desktop/deneme/main.go:5 +0x11 exit status 2
İstersek biz de kritik bir bilginin nil girilmesi gibi durumlarda programı durdurabiliriz. Bunun için panic() fonksiyonunu kullanacağız. Hemen bir örnek yapalım.
1
package main
2
3
import (
4
"fmt"
5
)
6
7
func TamIsim(Ad *string, Soyad *string) {
8
if Ad == nil {
9
panic("Ad nil olamaz")
10
}
11
if Soyad == nil {
12
panic("Soyad nil olamaz")
13
}
14
fmt.Printf("%s %s\n", *Ad, *Soyad)
15
fmt.Println("TamIsim fonksiyonu bitti")
16
}
17
18
func main() {
19
Ad := "Yusuf"
20
TamIsim(&Ad, nil)
21
fmt.Println("Ana fonksiyon da bitti")
22
}
Copied!
Çıktımız burada:
panic: Soyad nil olamaz goroutine 1 [running]: main.TamIsim(0xc00007df30, 0x0) /Users/Y/Desktop/main.go:12 +0x19a main.main() /Users/Y/Desktop/main.go:20 +0x65 exit status 2
Burada Soyad değişkeni tanımsız olduğu için programımız durdu. Aynı şekilde recover() fonksiyonu ile panic() fonksiyonundan gelen veriyi alabilir, ana fonksiyonumuzun kapanmasına da engel olabiliriz. Bunun için de bir örnek yapalım.
1
package main
2
3
import (
4
"fmt"
5
)
6
7
func TamIsim(Ad *string, Soyad *string) {
8
if Ad == nil {
9
panic("Ad nil olamaz")
10
}
11
if Soyad == nil {
12
panic("Soyad nil olamaz")
13
}
14
fmt.Printf("%s %s\n", *Ad, *Soyad)
15
fmt.Println("TamIsim fonksiyonu bitti")
16
}
17
18
func main() {
19
Ad := "Yusuf"
20
defer func() {
21
if r := recover(); r != nil {
22
fmt.Println("Panik Yok : ", r)
23
}
24
}()
25
TamIsim(&Ad, nil)
26
fmt.Println("Ana fonksiyon da bitti")
27
}
Copied!
Çıktımız burada :
Panik Yok : Soyad nil olamaz
Last modified 1yr ago
Copy link